//+------------------------------------------------------------------+
//|                                                 Goertzel browser |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2

//
//
//
//
//

extern int    Price                  = PRICE_CLOSE;
extern int    BarToCalculate         = 1;
extern int    StartAtCycle           = 1;
extern int    UseTopCycles           = 2;
extern int    MaxPer                 = 120;
extern int    WindowSize             = 100;
extern bool   UseCycleList           = false;
extern int    Cycle1                 = 1;
extern int    Cycle2                 = 1;
extern int    Cycle3                 = 1;
extern int    Cycle4                 = 1;
extern int    Cycle5                 = 1;
extern int    Offset                 = 0;
extern bool   SubtractNoise          = false;
extern bool   ListOfCyclesVisible    = true;
extern string ListOfCyclesID         = "GortzelBrowser";
extern int    ListOfCyclesCorner     = 1;
extern color  ListOfCyclesTextColor  = DimGray;
extern color  ListOfCyclesValueColor = PaleVioletRed;

//
//
//
//
//

double values[];
double goertzel[];
double work[][30];
string name;
int    ListOfCyclesWindow;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(6);
   IndicatorBuffers(2);
      SetIndexBuffer(0, goertzel);
      SetIndexBuffer(1, values);

      //
      //
      //
      //
      //
      
      MaxPer         = MathMax(MaxPer,2);
      WindowSize     = MathMax(WindowSize,3*MaxPer);
      BarToCalculate = MathMax(BarToCalculate,0);
      name           = ListOfCyclesID+" - Gortzel browser ("+BarToCalculate+")";
   IndicatorShortName(name);
   return (0);
}

int deinit() { deleteCycles(); return (0); }

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int limit,i,k;

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (Bars < 3*MaxPer)
                     { Comment(" Not Enough bars: you need 3*MaxPer -> " + DoubleToStr(3 * MaxPer, 0)); return (0); }

   //
   //
   //
   //
   //
   
      for(i = limit; i >= 0; i--) values[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         
         int number_of_cycles = iGoertzel(BarToCalculate,WindowSize,work);
                                showCycles(number_of_cycles);

      
      //
      //
      //
      //
      //
            
      for (i=0; i<WindowSize; i++)
      {
         goertzel[i] = 0;
         if (UseCycleList)
         {
            if (Cycle1 > 0) goertzel[i] += work[Bars-i-1][Cycle1];
            if (Cycle2 > 0) goertzel[i] += work[Bars-i-1][Cycle2];
            if (Cycle3 > 0) goertzel[i] += work[Bars-i-1][Cycle3];
            if (Cycle4 > 0) goertzel[i] += work[Bars-i-1][Cycle4];
            if (Cycle5 > 0) goertzel[i] += work[Bars-i-1][Cycle5];
         }
         else
         {
            for (k=StartAtCycle; k<StartAtCycle+UseTopCycles; k++) goertzel[i] += work[Bars-i-1][k];
            if (SubtractNoise)
                  for (k = StartAtCycle+UseTopCycles; k<number_of_cycles+1; k++) goertzel[i] = goertzel[i]-work[Bars-i-1][k];
         }
      }

   //
   //
   //
   //
   //
   
   SetIndexDrawBegin(0,Bars-WindowSize+1);      
   return (0);
}



//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double  goeWork1[];
double  goeWork2[];
double  goeWork3[];
double  goeWork4[];
double  cyclebuffer[];
double  amplitudebuffer[];
double  phasebuffer[];
#define pi 3.1415926535

//
//
//
//
//

int iGoertzel(int forBar, int numBars, double& goeWork5[][])
{
   if (ArraySize(goeWork4)!=3*MaxPer+1)
   {
         ArrayResize(goeWork1,3*MaxPer+1); ArrayResize(goeWork2,3*MaxPer+1);
         ArrayResize(goeWork3,3*MaxPer+1); ArrayResize(goeWork4,3*MaxPer+1);
   }
   if (ArraySize(cyclebuffer)!=MaxPer+1)
   {
      ArrayResize(cyclebuffer    ,MaxPer+1);
      ArrayResize(amplitudebuffer,MaxPer+1);
      ArrayResize(phasebuffer    ,MaxPer+1);
   }
   if (ArrayRange(goeWork5,0)!=Bars) ArrayResize(goeWork5,Bars);
   
   
   //
   //
   //
   //
   //

      double temp1 =  values[forBar + 3*MaxPer-1];
      double temp2 = (values[forBar] - temp1) / (3*MaxPer-1);
      double temp3;
   
         for (int k = 3*MaxPer; k>=1; k--) 
         {
            goeWork4[k] = values[forBar+k-1] - (temp1 + temp2*(3*MaxPer-k));
            goeWork3[k] = 0;
         }
         goeWork3[0]=0;
   
      //
      //
      //
      //
      //

      for (k = 2; k <= MaxPer; k++)
      {
         double w = 0;
         double x = 0;
         double y = 0;
         double z = MathPow(k, -1);
            temp1 = 2.0 * MathCos(2.0 * pi * z);
            for (int i = 3*MaxPer; i >= 1; i--)
            {
               w = temp1 * x - y + goeWork4[i];
               y = x;
               x = w;
            }
            temp2 = x - y / 2.0 * temp1;
                     if (temp2 == 0.0) temp2 = 0.0000001;
            temp3 = y * MathSin(2.0 * pi * z);

            goeWork1[k] = MathPow(temp2,2) + MathPow(temp3,2);
            goeWork2[k] = MathArctan(temp3 / temp2);

            if (temp2 < 0.0) goeWork2[k] += pi;
            else
               if (temp3 < 0.0) goeWork2[k] += 2.0 * pi;
      }

      //
      //
      //
      //
      //
   
      for (k = 3; k < MaxPer; k++)
            if (goeWork1[k] > goeWork1[k+1] && goeWork1[k] > goeWork1[k-1])
                  goeWork3[k] = k * MathPow(10, -4);
            else  goeWork3[k] = 0.0;

   //
   //
   //    extract cycles
   //
   //
   
      
      int number_of_cycles = 0;
         for (i = 0; i<MaxPer+2; i++)
            if (goeWork3[i] > 0.0)
            {
               number_of_cycles++;
                  cyclebuffer[number_of_cycles]     = MathRound(10000.0 * goeWork3[i]);
                  amplitudebuffer[number_of_cycles] = goeWork1[i];
                  phasebuffer[number_of_cycles]     = goeWork2[i];
            }

         //
         //
         //    order cycles
         //
         //
         
         for (i = 1;   i < number_of_cycles;   i++)
         for (k = i+1; k < number_of_cycles+1; k++)
            if (amplitudebuffer[k] > amplitudebuffer[i])
            {
               y = amplitudebuffer[i];
               w = cyclebuffer[i];
               x = phasebuffer[i];
                       amplitudebuffer[i] = amplitudebuffer[k];
                       cyclebuffer[i]     = cyclebuffer[k];
                       phasebuffer[i]     = phasebuffer[k];
               amplitudebuffer[k] = y;
               cyclebuffer[k]     = w;
               phasebuffer[k]     = x;
            }

         //
         //
         //    calculate waves
         //
         //
         
         for (i=1; i<number_of_cycles+1; i++)
         {
            int    cycle     = cyclebuffer[i];
            double amplitude = amplitudebuffer[i];
            double phase     = phasebuffer[i];
                   z         = phase * pi / 2.0;

            for (k=MaxPer; k<WindowSize+MaxPer; k++) goeWork5[Bars-(k-MaxPer)-1][i] = amplitude * MathSin((2.0*pi/cycle) * (k+Offset+cycle/2 + z*cycle));
         }
      
   //
   //
   //
   //
   //
         
   return(number_of_cycles);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

void showCycles(int number_of_cycles)
{
   if (ListOfCyclesVisible)
   {
      deleteCycles(); ListOfCyclesWindow = WindowFind(name);
      
      //
      //
      //    normalize amplitude values display to < 100
      //
      //
      
         double max = 0;
            for (int i = 1; i < number_of_cycles + 1; i++) max= MathMax(amplitudebuffer[i],max);
            double coeff = MathCeil(MathLog(max)/MathLog(10));
                   coeff = MathMax(coeff-2,0);
         
            for (i = 1; i < number_of_cycles + 1; i++)
                  showCycle(i,number_of_cycles+1,cyclebuffer[i],amplitudebuffer[i]/MathPow(10,coeff),phasebuffer[i]);
                  showCycle(i,number_of_cycles+1,-1            ,coeff                               ,             0);
   }               
}

//
//
//
//
//

void deleteCycles()
{
   string searchFor    = ListOfCyclesID+":";
   int    searchLength = StringLen(searchFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i); if (StringSubstr(name,0,searchLength) == searchFor)
                                       ObjectDelete(name);
   }
}

//
//
//
//
//

double xpos1[] = {240,220,150,103,53,10};
double xpos2[] = {10,75,95,160,212,255};

void showCycle(int cycleNo, int totalCycles, double period, double amplitude, double phase)
{
   double xpos[6];
   int    ypos;
   
   //
   //
   //
   //
   //
      
      if (ListOfCyclesCorner== 2 || ListOfCyclesCorner==3) 
            ypos = (totalCycles-cycleNo+1)*11;
      else  ypos = cycleNo*11;         
      if (ListOfCyclesCorner== 1 || ListOfCyclesCorner==3)
            ArrayCopy(xpos,xpos1);
      else  ArrayCopy(xpos,xpos2);
      
      //
      //
      //
      //
      //
      
      if (period==-1)
         if (ListOfCyclesCorner== 1 || ListOfCyclesCorner==3)
               setElement(cycleNo+"-6",xpos[5],ypos,ListOfCyclesTextColor ,"* amplitude multiplier : 10^"+DoubleToStr(amplitude,0),8);
         else  setElement(cycleNo+"-6",xpos[0],ypos,ListOfCyclesTextColor ,"* amplitude multiplier : 10^"+DoubleToStr(amplitude,0),8);
      else
      {         
         setElement(cycleNo+"-0",xpos[0],ypos,ListOfCyclesTextColor ,cycleNo+" period :");
         setElement(cycleNo+"-1",xpos[1],ypos,ListOfCyclesValueColor,DoubleToStr(period,0));
         setElement(cycleNo+"-2",xpos[2],ypos,ListOfCyclesTextColor ,"amplitude :");
         setElement(cycleNo+"-3",xpos[3],ypos,ListOfCyclesValueColor,DoubleToStr(amplitude,4));
         setElement(cycleNo+"-4",xpos[4],ypos,ListOfCyclesTextColor ,"phase :");
         setElement(cycleNo+"-5",xpos[5],ypos,ListOfCyclesValueColor,DoubleToStr(phase,4));
      }         
}

//
//
//
//
//

void setElement(string element, int x, int y, color ecolor=Silver, string text = "", int fontsize = 9, string fontname="Arial", int angle=0)
{
   string name = ListOfCyclesID+":"+element;
   ObjectCreate(name, OBJ_LABEL, ListOfCyclesWindow, 0, 0);
      ObjectSet(name, OBJPROP_XDISTANCE, x);
      ObjectSet(name, OBJPROP_YDISTANCE, y);
      ObjectSet(name, OBJPROP_BACK, FALSE);
      ObjectSet(name, OBJPROP_CORNER, ListOfCyclesCorner);
      ObjectSet(name, OBJPROP_ANGLE, angle);
      ObjectSetText(name, text, fontsize, fontname, ecolor);
}